package com.lilosoft.api.service;

import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.lilosoft.api.service.complexWindow.CommonData;
import com.lilosoft.api.service.complexWindow.ComplexWindowAbstract;
import com.lilosoft.core.utils.Base64Helper;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class ApplyService extends PublicService {

    /**
     * 网上申报
     */
    public String webApply(HashMap<String, Object> paramsMap) throws Exception {
        logger.info(JSONUtil.toJsonStr(paramsMap));
        //事项编码，通过这个获取需要提交到综合窗口服务  空不提交
        String itemCode = (String) paramsMap.getOrDefault("ItemCode", "");
        ComplexWindowAbstract complexWindowAbstract = ComplexWindowAbstract.newType(itemCode);
        CommonData commonData = new CommonData();
        complexWindowAbstract.doHandleWork(commonData);


        if (!paramsMap.containsKey("address")) {
            paramsMap.put("address", "");//办事人联系地址
        }
        HashMap<String, Object> formData = new HashMap<>();//需要提交的表单数据（不同事项不同字段），需根据formId获取表单字段
        String result = "";//返回结果
        boolean check = true;//事项是否查找到，默认事项已经查找到
        if ("46020400WJ-XK-1104".equals(itemCode)) {//公共场所卫生许可证注销
            ggcswxxkzx(paramsMap, formData);
        } else {
            check = false;
            result = "未查询到相关事项;";
            logger.error(result + JSONUtil.toJsonStr(paramsMap));
        }
        if (check) {
            //通用上传接口
            result = super.webApply(paramsMap, formData);
        }
        return result;

    }

    /**
     * 公共场所卫生许可证注销
     */
    private void ggcswxxkzx(HashMap<String, Object> paramsMap, HashMap<String, Object> formData) {
        //组装第三步提交表单需要的数据，此数据是根据当前事项表单字段获取
        formData.put("ShenQingRiQi", DateUtil.today());//申请日期
        formData.put("XuKeZhengHao", "");//许可证号
        formData.put("ZhuXiaoYuanYin", "");//注销原因
        formData.put("ShenQingDanWei", paramsMap.get("GeRenDanWeiMingChen"));//申请单位
        formData.put("DianHua", paramsMap.get("ApplicantMobile"));//电话
        formData.put("FaDingDaiBiaoRen", paramsMap.get("FaDingDaiBiaoRen"));//法定代表人
        formData.put("TongYiSheHuiXinYongDaiMa", paramsMap.get("TongYiSheHuiXinYongDaiMa"));//统一社会信用代码
        JSONArray materials = JSONUtil.parseArray(paramsMap.get("materials"));//材料列表
        for (int n = 0, m = materials.size(); n < m; n++) {
            JSONObject jsonObject1 = materials.getJSONObject(n);
            String fileId = jsonObject1.getStr("fileId");//当前材料编码
            if ("hygiene".equals(fileId) || "business".equals(fileId)) {//公共场所卫生许可证/营业执照归为一类
                jsonObject1.putOpt("fileCode", "46020400WJ-XK-1104-00003");
            } else if ("applicationForm".equals(fileId) || "applicationText".equals(fileId)) {//关于注销公共场所卫生许可证的申请书/申请表归为一类
                jsonObject1.putOpt("fileCode", "46020400WJ-XK-1104-00002");
            } else if ("idcard".equals(fileId)) {//多个身份证归为一类
                jsonObject1.putOpt("fileCode", "46020400WJ-XK-1104-00001");
            } else {//多余材料归为证照类
                jsonObject1.putOpt("fileCode", "46020400WJ-XK-1104-00003");
            }
        }
        paramsMap.put("materials", materials);
        paramsMap.put("objectType", "1");
        paramsMap.put("applyName", paramsMap.get("FaDingDaiBiaoRen"));
        paramsMap.put("name", paramsMap.get("ApplicantName"));//办事人
        paramsMap.put("idcard", paramsMap.get("ApplicantID"));//身份证号码
        paramsMap.put("phone", paramsMap.get("ApplicantMobile"));//办事人手机号
        //paramsMap.put("address", paramsMap.get("ApplicantAddress"));//办事人联系地址
        //orgType 组织机构类型 政府机关 GovDept;个体工商户 PrivatBusiness 事业单位 Institutions 企业 Enterprise 社会团体 SocialOrg
        paramsMap.put("orgType", "PrivatBusiness");
    }

    //危险化学品经营许可证变更-法人变更
    private void wxhxpjyxkzbg(HashMap<String, Object> paramsMap, HashMap<String, Object> formData) {

        String temp = String.valueOf(formData.get("rpaData"));
        String rpaData = new String(Base64Helper.decode(temp));
        JSONObject rpa = JSONUtil.parseObj(rpaData);

        List<Map<String, Object>> handlings = new ArrayList<>();
        Map<String, Object> handling = new HashMap<>();
        handling.put("eventId", "852dcb2bb1aa70255871f75cf4868fa7");     //综窗平台事项id
        handling.put("objectType", "O");                                 //事项面对对象，P自然人，O法人
        handlings.add(handling);
        formData.put("handlings", handlings);
        formData.put("infoMap", null);                                   //表单信息，办件要素接口获取，此事项无
        Map<String, Object> applicantLegal = new HashMap<>();           //申请人信息
        applicantLegal.put("applicantName", null);                       //姓名
        applicantLegal.put("documentId", null);                          //证件类型
        applicantLegal.put("applicantIdNumber", null);                   //证件号码
        formData.put("applicantLegal", applicantLegal);
        Map<String, Object> legalProxy = new HashMap<>();               //法人信息，法人事项必填
        legalProxy.put("legalName", rpa.getStr("principalName"));                               //姓名
        legalProxy.put("documentId", null);                              //证件类型
        legalProxy.put("legalIdNumber", rpa.getStr("principalCardNumber"));                           //证件号码
        formData.put("legalProxy", legalProxy);
        List<String> itemsIds = new ArrayList<>();                      //情形项id集合
        itemsIds.add("d32d382b1b3ff119378c2813bd581aed");               //综窗平台情形项id
        formData.put("itemsIds", itemsIds);
    }


}
